module Vpsb
  class BaseTask
    @prepare_squence = []
    attr_reader :core, :prepare_squence

    def initialize(core)
      @core = core
    end

    def self.prepare_squence(*resource)
      (@prepare_squence ||= []).push(*resource)
    end

    def prepare_squence
      self.class.instance_variable_get(:@prepare_squence)
    end

    protected

    def prepare
      (prepare_squence || []).each{ |r| core.get(r) }
    end

    def reprepare
      (prepare_squence || []).each{ |r| core.get(r, force:true) }
    end

    def preparation_results
      (prepare_squence || []).inject({}){ |h, r| h[r] = core.get(r); h }
    end
  end
end
