module Vpsb
  module Commands
    class Build
      include AskSupport
      def initialize(core)
        @core = core
      end

      def execute(params)
        web_role.call
        deploy_bags.call
        apps_bags.call
        db_postgres_role.call
        db_postgres_bags.call if core.present?(:db_postgres_json)
        es_role.call          if ask_to_confirm("Do you want configure elasticsearch")
        monit_role.call       if ask_to_confirm("Do you want configure monit(newrelic)")
        # packages_bags.call    if ask_to_confirm("Do you want to install additional apt-get apps")
        node.call
        ask { puts "Now everything will be installed. It should take 10-15 minutes. Click ENTER to start" }
      end

      private
      attr_reader :core

      def node
        Vpsb::Tasks::Node.new(core)
      end

      def apps_bags
        Vpsb::Tasks::AppsBags.new(core)
      end

      def deploy_bags
        Vpsb::Tasks::DeployBags.new(core)
      end

      def packages_bags
        Vpsb::Tasks::PackagesBags.new(core)
      end

      def db_postgres_bags
        Vpsb::Tasks::DbPostgresBags.new(core)
      end

      def db_postgres_role
        Vpsb::Tasks::DbPostgresRole.new(core)
      end

      def es_role
        Vpsb::Tasks::EsRole.new(core)
      end

      def monit_role
        Vpsb::Tasks::MonitRole.new(core)
      end

      def web_role
        Vpsb::Tasks::WebRole.new(core)
      end
    end
  end
end