module Vpsb
  module Commands
    class Init

      def execute(params)
        unless params.empty?
          name = params[0]
          p "creating directory #{name}"
          make_dir(name)
          enter_to_the_dir(name)
        end

        p 'installing all gems'
        install_all_gems
        p 'clone all repos'
        clone_all_repos
      end

      private

      GEMS  = %w{ knife-solo knife-digital_ocean librarian-chef knife-solo_data_bag }
      REPOS = %w{
        https://github.com/pniemczyk/bootstrap_rails_app_in_do.git
        https://github.com/pniemczyk/bootstrap_server_app_in_do.git
      }

      def install_all_gems
        GEMS.each{ |gem_name| gem_install(gem_name) }
      end

      def clone_all_repos
        REPOS.each { |source| git_clone(source) }
      end

      def enter_to_the_dir(name)
        Dir.chdir(name)
      end

      def make_dir(name)
        Dir.mkdir name
      end

      def gem_install(name)
        system("gem install #{name} --no-ri --no-rdoc")
      end

      def git_clone(source)
        system("git clone #{source}")
      end
    end
  end
end