module Vpsb
  module Commands
    class Setup
      include AskSupport
      attr_reader :core

      def initialize(core)
        @core = core
      end

      def execute(params)
        unless File.exist?(core.get(:knife_rb_path))
          return puts "You did not run init script, because i cannot find knife.rb file in bootstrap server app. ;)"
        end

        Vpsb::Tasks::DoApiAccess.new(core).call
        Vpsb::Tasks::DropletSshKeys.new(core).call
        Vpsb::Tasks::CreateDroplet.new(core).call
        Vpsb::Tasks::DropletSshUpdateConfig.new(core).call
      end
    end
  end
end