module Vpsb
  module Resources
    class AppBagsJson < BaseResource
      res :app_bags_json

      def call(data)
        template(data)
      end

      private

      def template(data)
        {
          id: "webapps",
          apps_base_dir: "/opt/www",
          apps: [
            {
              name: data.get(:app_name),
              type: "rails",
              default_env:  "production",
              host: data.get(:app_host),
              try_files: "/caches/$uri.html",
              nginx: {
                default: true,
                nginx_use_ssl: false
              },
              unicorn: {
                unicorn_workers: data.get(:unicorn_worker_processes),
                unicorn_timeout: data.get(:unicorn_worker_timeout)
              },
              app_env_variables: data.get(:app_env_variables)
            }
          ]
        }
      end
    end
  end
end