module Vpsb
  module Resources
    class AppEnvVariables < BaseAskResource
      res :app_env_variables
      question 'What are aplication env variables (default: RAILS_ENV=production)?'
      private

      def finalize(answer)
        return { 'RAILS_ENV' => 'production' } if answer.empty?
        answer.split(';').inject({}) do |h, i|
          res = i.to_s.split('=')
          key = res.shift.to_s.strip
          next if key.empty?
          h[key] = res.join('=').to_s.strip
          h
        end
      end

      def validate
        Proc.new { true }
      end
    end
  end
end