module Vpsb
  module Resources
    class DeployBagsJson < BaseResource
      res :deploy_bags_json

      def call(data)
        template(data)
      end

      private

      def template(data)
        {
          id: "deploy",
          username: "deploy",
          ssh_keys: data.get(:deploy_ssh_keys),
          password: data.get(:deploy_pass),
          groups: %w{www-data deploy},
          uid: 1001,
          shell: "/bin/bash",
          home: "/home/deploy",
          comment: "deployment user",
          manage_home: true,
          keychain: { id_dsa: "", "id_dsa.pub" => ""},
          to_known_hosts: [],
          www_dir: "/opt/www",
          env_variables_for_rvm: true,
          global_env_variables:{
            APPS_DIR:"/opt/www",
            RAILS_ENV: "production"
          }
        }
      end
    end
  end
end