module Vpsb
  module Resources
    class EsVersion < BaseAskResource
      res :es_version
      question 'Elasticsearch version (Default 1.1.0)?'
      default  '1.1.0'

      private

      def validate
        Proc.new do |answer|
          next true if answer.strip.empty?
          parts = answer.split('.')
          next false if parts.length != 3
          next false if (parts[0] + parts[1]).to_i <= 1
          true
        end
      end
    end
  end
end