module Vpsb
  module Resources
    class MonitRoleJson < BaseResource
      res :monit_role_json

      def call(data)
        template(data)
      end

      private

      def template(data)
        {
          name: "monit",
          description: "Monit Server Role",
          chef_type: "role",
          json_class: "Chef::Role",
          default_attributes: {
            new_relic:{
              license_key: data.get(:newrelic_lic),
              hostname: data.get(:hostname),
              keyserver:"keyserver.ubuntu.com"
            }
          },
          run_list: [
            "recipe[apt]",
            "recipe[newrelic-sysmond]"
          ]
        }
      end
    end
  end
end