module Vpsb
  module Resources
    class NodeJson < BaseResource
      res :node_json

      def call(data)
        template(data)
      end

      private

      def template(data)
        {
          chef_client:{
            encrypted_data_bag_secret: "~/chef-solo/data_bag_key"
          },
          run_list: run_list(data)
        }
      end

      def run_list(data)
        list = %w{recipe[chef-solo-search] role[base]}
        list << "role[es]" if data.present?(:es_json)
        list << "role[db]" if data.present?(:db_postgres_json)
        list << "role[web]"
        list << "role[monit]" if data.present?(:monit_role_json)
        list
      end
    end
  end
end