module Vpsb
  module Resources
    class RubyVersion < BaseAskResource
      res :ruby_version
      question 'What version of ruby you want to install (Default 2.1.2)?'
      default  '2.1.2'

      private

      def validate
        Proc.new do |answer|
          next true if answer.strip.empty?
          parts = answer.split('.')
          next false if parts.length != 3
          next false if (parts[0] + parts[1]).to_i < 18
          true
        end
      end
    end
  end
end