require 'json'
module Vpsb
  module Tasks
    class AppsBags < BaseTask
      include AskSupport
      PATH = 'bootstrap_server_app_in_do/data_bags/configs/webapps.json'

      prepare_squence :app_name, :app_host, :unicorn_worker_processes, :unicorn_worker_timeout
      prepare_squence :app_env_variables, :app_bags_json

      def call
        prepare

        ask_loop(proc {|r| process(r)}) do
          ap preparation_results
          p "Save this configuration y[es]/n[o]?"
        end

        Vpsb::Helpers::FileReplace.replace_json(PATH, core.get(:app_bags_json))
      end

      private

      def process(result)
        return true if result[0].to_s.downcase == 'y'
        reprepare
        false
      end
    end
  end
end


