module Vpsb
  module Tasks
    class EsRole < BaseTask
      include AskSupport

      PATH = 'bootstrap_server_app_in_do/roles/es.json'

      prepare_squence :es_version, :es_nofile, :es_memlock, :es_node_name, :es_cluster_name, :es_json

      def call
        prepare

        ask_loop(proc {|r| process(r)}) do
          ap preparation_results
          p "Save this configuration y[es]/n[o]?"
        end

        Vpsb::Helpers::FileReplace.replace_json(PATH, core.get(:es_json))
      end

      private

      def process(result)
        return true if result[0].to_s.downcase == 'y'
        reprepare
        false
      end
    end
  end
end


